/*
 * Copyright (c) 2020. Red Hat, Inc. and/or its affiliates.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.drools.serialization.protobuf.actions;

import org.drools.core.common.AgendaGroupQueueImpl;
import org.drools.core.common.InternalRuleFlowGroup;
import org.drools.core.marshalling.impl.MarshallerReaderContext;
import org.drools.core.marshalling.impl.MarshallerWriteContext;
import org.drools.serialization.protobuf.ProtobufMessages;
import org.drools.serialization.protobuf.ProtobufWorkingMemoryAction;

public class ProtobufDeactivateCallback extends AgendaGroupQueueImpl.DeactivateCallback implements ProtobufWorkingMemoryAction {

    public ProtobufDeactivateCallback( MarshallerReaderContext context, ProtobufMessages.ActionQueue.Action _action) {
        super( ( InternalRuleFlowGroup ) context.getWorkingMemory().getAgenda().getRuleFlowGroup( _action.getDeactivateCallback().getRuleflowGroup() ) );
    }

    @Override
    public ProtobufMessages.ActionQueue.Action serialize( MarshallerWriteContext context) {
        return ProtobufMessages.ActionQueue.Action.newBuilder()
                .setType( ProtobufMessages.ActionQueue.ActionType.DEACTIVATE_CALLBACK )
                .setDeactivateCallback( ProtobufMessages.ActionQueue.DeactivateCallback.newBuilder()
                        .setRuleflowGroup( ruleFlowGroup.getName() )
                        .build() )
                .build();
    }
}
